Subject: Re: [PATCH] Sam440ep support

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 06 May 2008 21:27:14 +1000

> Hrm... the problem is that you aren't supposed to make up sglists with
> the result of dma_alloc_coherent... It might be a limitation of our core
> DMA API, but that's we have to deal with today..
> 
> If you're going to make up sglists and call vmap, you should allocate
> pages with normal GFP. If that is a problem vs. DMA'bility of those
> pages, then ... we have a problem :-)
> 
> I don't think we can easily update the DMA API at this stage. What we
> could do is provide a way to retrieve the struct page array from the
> result of dma_alloc_coherent...

Another option is to allocate the pages with gfp, and then dma_map_sg
the result... However, if we do that, we do need to add a way to vmap
with the right protection in order to get a coherent (ie. non cacheable)
mapping. I'm not even sure all archs can do that....

Ben.